#include <windows.h>

#define BAUDRATE 1000000

#define FT_OK 0
#define MB_SERVICE_NOTIFICATION 0x00200000L
#define MB(p) MessageBox(NULL,p,"ftd2xx hook",MB_OK|MB_SERVICE_NOTIFICATION)

extern "C"{

FARPROC p_FT_Open;
FARPROC p_FT_Close;
FARPROC p_FT_Read;
FARPROC p_FT_Write;
FARPROC p_FT_IoCtl;
FARPROC p_FT_ResetDevice;
FARPROC p_FT_SetBaudRate;
FARPROC p_FT_SetDataCharacteristics;
FARPROC p_FT_SetFlowControl;
FARPROC p_FT_SetDtr;
FARPROC p_FT_ClrDtr;
FARPROC p_FT_SetRts;
FARPROC p_FT_ClrRts;
FARPROC p_FT_GetModemStatus;
FARPROC p_FT_SetChars;
FARPROC p_FT_Purge;
FARPROC p_FT_SetTimeouts;
FARPROC p_FT_GetQueueStatus;
FARPROC p_FT_SetEventNotification;
FARPROC p_FT_GetEventStatus;
FARPROC p_FT_GetStatus;
FARPROC p_FT_SetBreakOn;
FARPROC p_FT_SetBreakOff;
FARPROC p_FT_SetWaitMask;
FARPROC p_FT_WaitOnMask;
FARPROC p_FT_SetDivisor;
FARPROC p_FT_OpenEx;
FARPROC p_FT_ListDevices;
FARPROC p_FT_SetLatencyTimer;
FARPROC p_FT_GetLatencyTimer;
FARPROC p_FT_SetBitMode;
FARPROC p_FT_GetBitMode;
FARPROC p_FT_SetUSBParameters;
FARPROC p_FT_EraseEE;
FARPROC p_FT_ReadEE;
FARPROC p_FT_WriteEE;
FARPROC p_FT_EE_Program;
FARPROC p_FT_EE_Read;
FARPROC p_FT_EE_UARead;
FARPROC p_FT_EE_UASize;
FARPROC p_FT_EE_UAWrite;
FARPROC p_FT_W32_CreateFile;
FARPROC p_FT_W32_CloseHandle;
FARPROC p_FT_W32_ReadFile;
FARPROC p_FT_W32_WriteFile;
FARPROC p_FT_W32_GetOverlappedResult;
FARPROC p_FT_W32_ClearCommBreak;
FARPROC p_FT_W32_ClearCommError;
FARPROC p_FT_W32_EscapeCommFunction;
FARPROC p_FT_W32_GetCommModemStatus;
FARPROC p_FT_W32_GetCommState;
FARPROC p_FT_W32_GetCommTimeouts;
FARPROC p_FT_W32_GetLastError;
FARPROC p_FT_W32_PurgeComm;
FARPROC p_FT_W32_SetCommBreak;
FARPROC p_FT_W32_SetCommMask;
FARPROC p_FT_W32_SetCommState;
FARPROC p_FT_W32_SetCommTimeouts;
FARPROC p_FT_W32_SetupComm;
FARPROC p_FT_W32_WaitCommEvent;
FARPROC p_FT_GetDeviceInfo;
FARPROC p_FT_W32_CancelIo;
FARPROC p_FT_StopInTask;
FARPROC p_FT_RestartInTask;
FARPROC p_FT_SetResetPipeRetryCount;
FARPROC p_FT_ResetPort;
FARPROC p_FT_EE_ProgramEx;
FARPROC p_FT_EE_ReadEx;
FARPROC p_FT_CyclePort;
FARPROC p_FT_CreateDeviceInfoList;
FARPROC p_FT_GetDeviceInfoList;
FARPROC p_FT_GetDeviceInfoDetail;
FARPROC p_FT_SetDeadmanTimeout;
FARPROC p_FT_GetDriverVersion;
FARPROC p_FT_GetLibraryVersion;
FARPROC p_FT_W32_GetCommMask;
FARPROC p_FT_Rescan;
FARPROC p_FT_Reload;

char sbuf[256];
DWORD ret;

void SetCommCondition(HANDLE h){
	((DWORD(WINAPI*)(HANDLE,UCHAR,UCHAR,UCHAR))p_FT_SetDataCharacteristics)(h,8,0,0); //8-N-1
	((DWORD(WINAPI*)(HANDLE,USHORT,UCHAR,UCHAR))p_FT_SetFlowControl)(h,0x100,0,0); //FT_FLOW_RTS_CTS
	((DWORD(WINAPI*)(HANDLE,DWORD))p_FT_SetBaudRate)(h,BAUDRATE);
}

//__declspec( naked ) void WINAPI d_FT_Open() { _asm{ jmp p_FT_Open } }
__declspec(dllexport) DWORD WINAPI d_FT_Open(int i, HANDLE *h){
	ret = ((DWORD(WINAPI*)(int,HANDLE*))p_FT_Open)(i,h);
	if(ret==FT_OK) SetCommCondition(*h);
	return ret;
}
//__declspec( naked ) void WINAPI d_FT_Close() { _asm{ jmp p_FT_Close } }
//__declspec( naked ) void WINAPI d_FT_Read() { _asm{ jmp p_FT_Read } }
//__declspec( naked ) void WINAPI d_FT_Write() { _asm{ jmp p_FT_Write } }
//__declspec( naked ) void WINAPI d_FT_IoCtl() { _asm{ jmp p_FT_IoCtl } }
//__declspec( naked ) void WINAPI d_FT_ResetDevice() { _asm{ jmp p_FT_ResetDevice } }
//__declspec( naked ) void WINAPI d_FT_SetBaudRate() { _asm{ jmp p_FT_SetBaudRate } }
__declspec(dllexport) DWORD WINAPI d_FT_SetBaudRate(HANDLE h, DWORD br) { return FT_OK; }
//__declspec( naked ) void WINAPI d_FT_SetDataCharacteristics() { _asm{ jmp p_FT_SetDataCharacteristics } }
__declspec( dllexport ) DWORD WINAPI d_FT_SetDataCharacteristics(HANDLE h,UCHAR a,UCHAR b,UCHAR c) { return FT_OK; }
//__declspec( naked ) void WINAPI d_FT_SetFlowControl() { _asm{ jmp p_FT_SetFlowControl } }
__declspec( dllexport ) DWORD WINAPI d_FT_SetFlowControl(HANDLE h,USHORT a,UCHAR b,UCHAR c) { return FT_OK; }
//__declspec( naked ) void WINAPI d_FT_SetDtr() { _asm{ jmp p_FT_SetDtr } }
//__declspec( naked ) void WINAPI d_FT_ClrDtr() { _asm{ jmp p_FT_ClrDtr } }
//__declspec( naked ) void WINAPI d_FT_SetRts() { _asm{ jmp p_FT_SetRts } }
//__declspec( naked ) void WINAPI d_FT_ClrRts() { _asm{ jmp p_FT_ClrRts } }
//__declspec( naked ) void WINAPI d_FT_GetModemStatus() { _asm{ jmp p_FT_GetModemStatus } }
//__declspec( naked ) void WINAPI d_FT_SetChars() { _asm{ jmp p_FT_SetChars } }
//__declspec( naked ) void WINAPI d_FT_Purge() { _asm{ jmp p_FT_Purge } }
//__declspec( naked ) void WINAPI d_FT_SetTimeouts() { _asm{ jmp p_FT_SetTimeouts } }
//__declspec( naked ) void WINAPI d_FT_GetQueueStatus() { _asm{ jmp p_FT_GetQueueStatus } }
//__declspec( naked ) void WINAPI d_FT_SetEventNotification() { _asm{ jmp p_FT_SetEventNotification } }
//__declspec( naked ) void WINAPI d_FT_GetEventStatus() { _asm{ jmp p_FT_GetEventStatus } }
//__declspec( naked ) void WINAPI d_FT_GetStatus() { _asm{ jmp p_FT_GetStatus } }
//__declspec( naked ) void WINAPI d_FT_SetBreakOn() { _asm{ jmp p_FT_SetBreakOn } }
//__declspec( naked ) void WINAPI d_FT_SetBreakOff() { _asm{ jmp p_FT_SetBreakOff } }
//__declspec( naked ) void WINAPI d_FT_SetWaitMask() { _asm{ jmp p_FT_SetWaitMask } }
//__declspec( naked ) void WINAPI d_FT_WaitOnMask() { _asm{ jmp p_FT_WaitOnMask } }
//__declspec( naked ) void WINAPI d_FT_SetDivisor() { _asm{ jmp p_FT_SetDivisor } }
__declspec( dllexport ) DWORD WINAPI d_FT_SetDivisor(HANDLE h, DWORD div) { return FT_OK; }
//__declspec( naked ) void WINAPI d_FT_OpenEx() { _asm{ jmp p_FT_OpenEx } }
__declspec(dllexport) DWORD WINAPI d_FT_OpenEx(PVOID a,DWORD f,HANDLE* h){
	ret = ((DWORD(WINAPI*)(PVOID,DWORD,HANDLE*))p_FT_OpenEx)(a,f,h);
	if(ret==FT_OK) SetCommCondition(*h);
	return ret;
}
//__declspec( naked ) void WINAPI d_FT_ListDevices() { _asm{ jmp p_FT_ListDevices } }
//__declspec( naked ) void WINAPI d_FT_SetLatencyTimer() { _asm{ jmp p_FT_SetLatencyTimer } }
//__declspec( naked ) void WINAPI d_FT_GetLatencyTimer() { _asm{ jmp p_FT_GetLatencyTimer } }
//__declspec( naked ) void WINAPI d_FT_SetBitMode() { _asm{ jmp p_FT_SetBitMode } }
//__declspec( naked ) void WINAPI d_FT_GetBitMode() { _asm{ jmp p_FT_GetBitMode } }
//__declspec( naked ) void WINAPI d_FT_SetUSBParameters() { _asm{ jmp p_FT_SetUSBParameters } }
//__declspec( naked ) void WINAPI d_FT_EraseEE() { _asm{ jmp p_FT_EraseEE } }
//__declspec( naked ) void WINAPI d_FT_ReadEE() { _asm{ jmp p_FT_ReadEE } }
//__declspec( naked ) void WINAPI d_FT_WriteEE() { _asm{ jmp p_FT_WriteEE } }
//__declspec( naked ) void WINAPI d_FT_EE_Program() { _asm{ jmp p_FT_EE_Program } }
//__declspec( naked ) void WINAPI d_FT_EE_Read() { _asm{ jmp p_FT_EE_Read } }
//__declspec( naked ) void WINAPI d_FT_EE_UARead() { _asm{ jmp p_FT_EE_UARead } }
//__declspec( naked ) void WINAPI d_FT_EE_UASize() { _asm{ jmp p_FT_EE_UASize } }
//__declspec( naked ) void WINAPI d_FT_EE_UAWrite() { _asm{ jmp p_FT_EE_UAWrite } }
//__declspec( naked ) void WINAPI d_FT_W32_CreateFile() { _asm{ jmp p_FT_W32_CreateFile } }
//__declspec( naked ) void WINAPI d_FT_W32_CloseHandle() { _asm{ jmp p_FT_W32_CloseHandle } }
//__declspec( naked ) void WINAPI d_FT_W32_ReadFile() { _asm{ jmp p_FT_W32_ReadFile } }
//__declspec( naked ) void WINAPI d_FT_W32_WriteFile() { _asm{ jmp p_FT_W32_WriteFile } }
//__declspec( naked ) void WINAPI d_FT_W32_GetOverlappedResult() { _asm{ jmp p_FT_W32_GetOverlappedResult } }
//__declspec( naked ) void WINAPI d_FT_W32_ClearCommBreak() { _asm{ jmp p_FT_W32_ClearCommBreak } }
//__declspec( naked ) void WINAPI d_FT_W32_ClearCommError() { _asm{ jmp p_FT_W32_ClearCommError } }
//__declspec( naked ) void WINAPI d_FT_W32_EscapeCommFunction() { _asm{ jmp p_FT_W32_EscapeCommFunction } }
//__declspec( naked ) void WINAPI d_FT_W32_GetCommModemStatus() { _asm{ jmp p_FT_W32_GetCommModemStatus } }
//__declspec( naked ) void WINAPI d_FT_W32_GetCommState() { _asm{ jmp p_FT_W32_GetCommState } }
//__declspec( naked ) void WINAPI d_FT_W32_GetCommTimeouts() { _asm{ jmp p_FT_W32_GetCommTimeouts } }
//__declspec( naked ) void WINAPI d_FT_W32_GetLastError() { _asm{ jmp p_FT_W32_GetLastError } }
//__declspec( naked ) void WINAPI d_FT_W32_PurgeComm() { _asm{ jmp p_FT_W32_PurgeComm } }
//__declspec( naked ) void WINAPI d_FT_W32_SetCommBreak() { _asm{ jmp p_FT_W32_SetCommBreak } }
//__declspec( naked ) void WINAPI d_FT_W32_SetCommMask() { _asm{ jmp p_FT_W32_SetCommMask } }
//__declspec( naked ) void WINAPI d_FT_W32_SetCommState() { _asm{ jmp p_FT_W32_SetCommState } }
//__declspec( naked ) void WINAPI d_FT_W32_SetCommTimeouts() { _asm{ jmp p_FT_W32_SetCommTimeouts } }
//__declspec( naked ) void WINAPI d_FT_W32_SetupComm() { _asm{ jmp p_FT_W32_SetupComm } }
//__declspec( naked ) void WINAPI d_FT_W32_WaitCommEvent() { _asm{ jmp p_FT_W32_WaitCommEvent } }
//__declspec( naked ) void WINAPI d_FT_GetDeviceInfo() { _asm{ jmp p_FT_GetDeviceInfo } }
//__declspec( naked ) void WINAPI d_FT_W32_CancelIo() { _asm{ jmp p_FT_W32_CancelIo } }
//__declspec( naked ) void WINAPI d_FT_StopInTask() { _asm{ jmp p_FT_StopInTask } }
//__declspec( naked ) void WINAPI d_FT_RestartInTask() { _asm{ jmp p_FT_RestartInTask } }
//__declspec( naked ) void WINAPI d_FT_SetResetPipeRetryCount() { _asm{ jmp p_FT_SetResetPipeRetryCount } }
//__declspec( naked ) void WINAPI d_FT_ResetPort() { _asm{ jmp p_FT_ResetPort } }
//__declspec( naked ) void WINAPI d_FT_EE_ProgramEx() { _asm{ jmp p_FT_EE_ProgramEx } }
//__declspec( naked ) void WINAPI d_FT_EE_ReadEx() { _asm{ jmp p_FT_EE_ReadEx } }
//__declspec( naked ) void WINAPI d_FT_CyclePort() { _asm{ jmp p_FT_CyclePort } }
//__declspec( naked ) void WINAPI d_FT_CreateDeviceInfoList() { _asm{ jmp p_FT_CreateDeviceInfoList } }
//__declspec( naked ) void WINAPI d_FT_GetDeviceInfoList() { _asm{ jmp p_FT_GetDeviceInfoList } }
//__declspec( naked ) void WINAPI d_FT_GetDeviceInfoDetail() { _asm{ jmp p_FT_GetDeviceInfoDetail } }
//__declspec( naked ) void WINAPI d_FT_SetDeadmanTimeout() { _asm{ jmp p_FT_SetDeadmanTimeout } }
//__declspec( naked ) void WINAPI d_FT_GetDriverVersion() { _asm{ jmp p_FT_GetDriverVersion } }
//__declspec( naked ) void WINAPI d_FT_GetLibraryVersion() { _asm{ jmp p_FT_GetLibraryVersion } }
//__declspec( naked ) void WINAPI d_FT_W32_GetCommMask() { _asm{ jmp p_FT_W32_GetCommMask } }
//__declspec( naked ) void WINAPI d_FT_Rescan() { _asm{ jmp p_FT_Rescan } }
//__declspec( naked ) void WINAPI d_FT_Reload() { _asm{ jmp p_FT_Reload } }
}
HINSTANCE h_original;
BOOL APIENTRY DllMain(HANDLE hModule,
                      DWORD  ul_reason_for_call,
                      LPVOID lpReserved)
{
    switch(ul_reason_for_call)
    {
    case DLL_PROCESS_ATTACH:
        h_original = LoadLibrary("ftd2xx64.dll");
		if(h_original == NULL){
			MB("Error loading FTD2XX64.DLL");
			return FALSE;
		}
        p_FT_Open = GetProcAddress(h_original, "FT_Open");
        p_FT_Close = GetProcAddress(h_original, "FT_Close");
        p_FT_Read = GetProcAddress(h_original, "FT_Read");
        p_FT_Write = GetProcAddress(h_original, "FT_Write");
        p_FT_IoCtl = GetProcAddress(h_original, "FT_IoCtl");
        p_FT_ResetDevice = GetProcAddress(h_original, "FT_ResetDevice");
        p_FT_SetBaudRate = GetProcAddress(h_original, "FT_SetBaudRate");
        p_FT_SetDataCharacteristics = GetProcAddress(h_original, "FT_SetDataCharacteristics");
        p_FT_SetFlowControl = GetProcAddress(h_original, "FT_SetFlowControl");
        p_FT_SetDtr = GetProcAddress(h_original, "FT_SetDtr");
        p_FT_ClrDtr = GetProcAddress(h_original, "FT_ClrDtr");
        p_FT_SetRts = GetProcAddress(h_original, "FT_SetRts");
        p_FT_ClrRts = GetProcAddress(h_original, "FT_ClrRts");
        p_FT_GetModemStatus = GetProcAddress(h_original, "FT_GetModemStatus");
        p_FT_SetChars = GetProcAddress(h_original, "FT_SetChars");
        p_FT_Purge = GetProcAddress(h_original, "FT_Purge");
        p_FT_SetTimeouts = GetProcAddress(h_original, "FT_SetTimeouts");
        p_FT_GetQueueStatus = GetProcAddress(h_original, "FT_GetQueueStatus");
        p_FT_SetEventNotification = GetProcAddress(h_original, "FT_SetEventNotification");
        p_FT_GetEventStatus = GetProcAddress(h_original, "FT_GetEventStatus");
        p_FT_GetStatus = GetProcAddress(h_original, "FT_GetStatus");
        p_FT_SetBreakOn = GetProcAddress(h_original, "FT_SetBreakOn");
        p_FT_SetBreakOff = GetProcAddress(h_original, "FT_SetBreakOff");
        p_FT_SetWaitMask = GetProcAddress(h_original, "FT_SetWaitMask");
        p_FT_WaitOnMask = GetProcAddress(h_original, "FT_WaitOnMask");
        p_FT_SetDivisor = GetProcAddress(h_original, "FT_SetDivisor");
        p_FT_OpenEx = GetProcAddress(h_original, "FT_OpenEx");
        p_FT_ListDevices = GetProcAddress(h_original, "FT_ListDevices");
        p_FT_SetLatencyTimer = GetProcAddress(h_original, "FT_SetLatencyTimer");
        p_FT_GetLatencyTimer = GetProcAddress(h_original, "FT_GetLatencyTimer");
        p_FT_SetBitMode = GetProcAddress(h_original, "FT_SetBitMode");
        p_FT_GetBitMode = GetProcAddress(h_original, "FT_GetBitMode");
        p_FT_SetUSBParameters = GetProcAddress(h_original, "FT_SetUSBParameters");
        p_FT_EraseEE = GetProcAddress(h_original, "FT_EraseEE");
        p_FT_ReadEE = GetProcAddress(h_original, "FT_ReadEE");
        p_FT_WriteEE = GetProcAddress(h_original, "FT_WriteEE");
        p_FT_EE_Program = GetProcAddress(h_original, "FT_EE_Program");
        p_FT_EE_Read = GetProcAddress(h_original, "FT_EE_Read");
        p_FT_EE_UARead = GetProcAddress(h_original, "FT_EE_UARead");
        p_FT_EE_UASize = GetProcAddress(h_original, "FT_EE_UASize");
        p_FT_EE_UAWrite = GetProcAddress(h_original, "FT_EE_UAWrite");
        p_FT_W32_CreateFile = GetProcAddress(h_original, "FT_W32_CreateFile");
        p_FT_W32_CloseHandle = GetProcAddress(h_original, "FT_W32_CloseHandle");
        p_FT_W32_ReadFile = GetProcAddress(h_original, "FT_W32_ReadFile");
        p_FT_W32_WriteFile = GetProcAddress(h_original, "FT_W32_WriteFile");
        p_FT_W32_GetOverlappedResult = GetProcAddress(h_original, "FT_W32_GetOverlappedResult");
        p_FT_W32_ClearCommBreak = GetProcAddress(h_original, "FT_W32_ClearCommBreak");
        p_FT_W32_ClearCommError = GetProcAddress(h_original, "FT_W32_ClearCommError");
        p_FT_W32_EscapeCommFunction = GetProcAddress(h_original, "FT_W32_EscapeCommFunction");
        p_FT_W32_GetCommModemStatus = GetProcAddress(h_original, "FT_W32_GetCommModemStatus");
        p_FT_W32_GetCommState = GetProcAddress(h_original, "FT_W32_GetCommState");
        p_FT_W32_GetCommTimeouts = GetProcAddress(h_original, "FT_W32_GetCommTimeouts");
        p_FT_W32_GetLastError = GetProcAddress(h_original, "FT_W32_GetLastError");
        p_FT_W32_PurgeComm = GetProcAddress(h_original, "FT_W32_PurgeComm");
        p_FT_W32_SetCommBreak = GetProcAddress(h_original, "FT_W32_SetCommBreak");
        p_FT_W32_SetCommMask = GetProcAddress(h_original, "FT_W32_SetCommMask");
        p_FT_W32_SetCommState = GetProcAddress(h_original, "FT_W32_SetCommState");
        p_FT_W32_SetCommTimeouts = GetProcAddress(h_original, "FT_W32_SetCommTimeouts");
        p_FT_W32_SetupComm = GetProcAddress(h_original, "FT_W32_SetupComm");
        p_FT_W32_WaitCommEvent = GetProcAddress(h_original, "FT_W32_WaitCommEvent");
        p_FT_GetDeviceInfo = GetProcAddress(h_original, "FT_GetDeviceInfo");
        p_FT_W32_CancelIo = GetProcAddress(h_original, "FT_W32_CancelIo");
        p_FT_StopInTask = GetProcAddress(h_original, "FT_StopInTask");
        p_FT_RestartInTask = GetProcAddress(h_original, "FT_RestartInTask");
        p_FT_SetResetPipeRetryCount = GetProcAddress(h_original, "FT_SetResetPipeRetryCount");
        p_FT_ResetPort = GetProcAddress(h_original, "FT_ResetPort");
        p_FT_EE_ProgramEx = GetProcAddress(h_original, "FT_EE_ProgramEx");
        p_FT_EE_ReadEx = GetProcAddress(h_original, "FT_EE_ReadEx");
        p_FT_CyclePort = GetProcAddress(h_original, "FT_CyclePort");
        p_FT_CreateDeviceInfoList = GetProcAddress(h_original, "FT_CreateDeviceInfoList");
        p_FT_GetDeviceInfoList = GetProcAddress(h_original, "FT_GetDeviceInfoList");
        p_FT_GetDeviceInfoDetail = GetProcAddress(h_original, "FT_GetDeviceInfoDetail");
        p_FT_SetDeadmanTimeout = GetProcAddress(h_original, "FT_SetDeadmanTimeout");
        p_FT_GetDriverVersion = GetProcAddress(h_original, "FT_GetDriverVersion");
        p_FT_GetLibraryVersion = GetProcAddress(h_original, "FT_GetLibraryVersion");
        p_FT_W32_GetCommMask = GetProcAddress(h_original, "FT_W32_GetCommMask");
        p_FT_Rescan = GetProcAddress(h_original, "FT_Rescan");
        p_FT_Reload = GetProcAddress(h_original, "FT_Reload");
        break;
    case DLL_THREAD_ATTACH:
        break;
    case DLL_THREAD_DETACH:
        break;
    case DLL_PROCESS_DETACH:
        FreeLibrary(h_original);
        break;
    default:
        break;
    }
    return TRUE;
}
